Index: issm/trunk/src/c/modules/ElementCoordinatesx/ElementCoordinatesx.cpp
===================================================================
--- issm/trunk/src/c/modules/ElementCoordinatesx/ElementCoordinatesx.cpp	(revision 26744)
+++ issm/trunk/src/c/modules/ElementCoordinatesx/ElementCoordinatesx.cpp	(revision 26744)
@@ -0,0 +1,94 @@
+/*!\file ElementCoordinatesx
+ * \brief: compute a vector xe,ye and ze of element centroid coordinates by
+ * marching through all our elements.
+ */
+
+#include "./ElementCoordinatesx.h"
+
+#include "../../shared/shared.h"
+#include "../../toolkits/toolkits.h"
+
+void ElementCoordinatesx( IssmDouble** pxe, IssmDouble** pye, IssmDouble** pze, IssmDouble** pareae, Elements* elements,bool spherical) { /*{{{*/
+
+	/*figure out how many vertices we have: */
+	int numberofelements=elements->NumberOfElements();
+
+	Vector<IssmDouble>* vxe=new Vector<IssmDouble>(numberofelements);
+	Vector<IssmDouble>* vye=new Vector<IssmDouble>(numberofelements);
+	Vector<IssmDouble>* vze=new Vector<IssmDouble>(numberofelements);
+	Vector<IssmDouble>* vareae=new Vector<IssmDouble>(numberofelements);
+
+	/*march through our elements: */
+	for(Object* & object : elements->objects){
+		Element* element=(Element*)object;
+		element->ElementCoordinates(vxe,vye,vze,vareae,spherical);
+	}
+
+	/*Assemble*/
+	vxe->Assemble();
+	vye->Assemble();
+	vze->Assemble();
+	vareae->Assemble();
+
+	/*serialize: */
+	IssmDouble* xe=vxe->ToMPISerial();
+	IssmDouble* ye=vye->ToMPISerial();
+	IssmDouble* ze=vze->ToMPISerial();
+	IssmDouble* areae=vareae->ToMPISerial();
+
+	/*Free ressources: */
+	delete vxe;
+	delete vye;
+	delete vze;
+	delete vareae;
+
+	/*output: */
+	if(pxe) *pxe=xe;
+	else xDelete<IssmDouble>(xe);
+	if(pye) *pye=ye;
+	else xDelete<IssmDouble>(ye);
+	if(pze) *pze=ze;
+	else xDelete<IssmDouble>(ze);
+	if(pareae) *pareae=areae;
+	else xDelete<IssmDouble>(areae);
+
+} /*}}}*/
+void ElementCoordinatesx( IssmDouble** plonge, IssmDouble** plate, IssmDouble** pareae, Elements* elements) { /*{{{*/
+
+	/*figure out how many vertices we have: */
+	int numberofelements=elements->NumberOfElements();
+
+	Vector<IssmDouble>* vlonge=new Vector<IssmDouble>(numberofelements);
+	Vector<IssmDouble>* vlate=new Vector<IssmDouble>(numberofelements);
+	Vector<IssmDouble>* vareae=new Vector<IssmDouble>(numberofelements);
+
+	/*march through our elements: */
+	for(Object* & object : elements->objects){
+		Element* element=(Element*)object;
+		element->ElementCoordinates(vlonge,vlate,vareae);
+	}
+
+	/*Assemble*/
+	vlonge->Assemble();
+	vlate->Assemble();
+	vareae->Assemble();
+
+	/*serialize: */
+	IssmDouble* longe=vlonge->ToMPISerial();
+	IssmDouble* late=vlate->ToMPISerial();
+	IssmDouble* areae=vareae->ToMPISerial();
+
+	/*Free ressources: */
+	delete vlonge;
+	delete vlate;
+	delete vareae;
+
+	/*output: */
+	if(plonge) *plonge=longe;
+	else xDelete<IssmDouble>(longe);
+	if(plate) *plate=late;
+	else xDelete<IssmDouble>(late);
+	if(pareae) *pareae=areae;
+	else xDelete<IssmDouble>(areae);
+
+} /*}}}*/
Index: issm/trunk/src/c/modules/ElementCoordinatesx/ElementCoordinatesx.h
===================================================================
--- issm/trunk/src/c/modules/ElementCoordinatesx/ElementCoordinatesx.h	(revision 26744)
+++ issm/trunk/src/c/modules/ElementCoordinatesx/ElementCoordinatesx.h	(revision 26744)
@@ -0,0 +1,13 @@
+/*!\file:  ElementCoordinatesx.h
+ */ 
+
+#ifndef _ELEMENT_COORDINATESX_H
+#define _ELEMENT_COORDINATESX_H
+
+#include "../../classes/classes.h"
+
+/* local prototypes: */
+void ElementCoordinatesx( IssmDouble** pxe, IssmDouble** pye, IssmDouble** pze,IssmDouble** pareae, Elements* elements,bool spherical=false);
+void ElementCoordinatesx( IssmDouble** plonge, IssmDouble** plate, IssmDouble** pareae, Elements* elements);
+
+#endif  /* _ELEMENT_COORDINATESX_H */
Index: issm/trunk/src/c/modules/FloatingiceMeltingRatePicox/FloatingiceMeltingRatePicox.cpp
===================================================================
--- issm/trunk/src/c/modules/FloatingiceMeltingRatePicox/FloatingiceMeltingRatePicox.cpp	(revision 25994)
+++ issm/trunk/src/c/modules/FloatingiceMeltingRatePicox/FloatingiceMeltingRatePicox.cpp	(revision 26744)
@@ -57,5 +57,5 @@
 	for(Object* & object : femmodel->elements->objects){
 		Element* element=xDynamicCast<Element*>(object);
-		if(!element->IsIceInElement() || !element->IsFloating()) continue;
+		if(!element->IsIceInElement() || !element->IsAllFloating()) continue;
 		numvertices = element->GetNumberOfVertices();
 		distances=xNew<IssmDouble>(numvertices);
@@ -116,10 +116,12 @@
 		if(!element->IsOnBase()) continue;
 		Element* basalelement = element->SpawnBasalElement();
-		if(!basalelement->IsIceInElement() || !basalelement->IsFloating()) continue;
+		if(!basalelement->IsIceInElement() || !basalelement->IsAllFloating()){
+			if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
+			continue;
+		}
 		basalelement->GetInputValue(&boxid,BasalforcingsPicoBoxIdEnum);
 		basalelement->GetInputValue(&basinid,BasalforcingsPicoBasinIdEnum);
 		boxareas[basinid*maxbox+boxid]+=basalelement->GetHorizontalSurfaceArea();
-		basalelement->FindParam(&domaintype,DomainTypeEnum);
-		if(domaintype!=Domain2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
+		if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 	}
 
@@ -162,10 +164,13 @@
 	for(Object* & object : femmodel->elements->objects){
 		Element* element=xDynamicCast<Element*>(object);
+
+		/*Check whether we should continue*/
 		if(!element->IsOnBase()) continue;
+		if(!element->IsIceInElement() || !element->IsAllFloating()) continue;
+		int el_boxid;
+		element->GetInputValue(&el_boxid,BasalforcingsPicoBoxIdEnum);
+		if(el_boxid!=boxid) continue;
+
 		Element* basalelement = element->SpawnBasalElement();
-		if(!basalelement->IsIceInElement() || !basalelement->IsFloating()) continue;
-		int el_boxid;
-		basalelement->GetInputValue(&el_boxid,BasalforcingsPicoBoxIdEnum);
-		if(el_boxid!=boxid) continue;
 
 		Input* tocs_input=basalelement->GetInput(BasalforcingsPicoSubShelfOceanTempEnum); _assert_(tocs_input); 
@@ -180,6 +185,6 @@
 		toc_weighted_avg[basinid]+=toc*area;
 		soc_weighted_avg[basinid]+=soc*area;
-		basalelement->FindParam(&domaintype,DomainTypeEnum);
-		if(domaintype!=Domain2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
+
+		if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 	}
 
@@ -203,11 +208,13 @@
 		for(Object* & object : femmodel->elements->objects){
 			Element* element=xDynamicCast<Element*>(object);
+
+			/*Check whether we should continue or not*/
 			if(!element->IsOnBase()) continue;
+			if(!element->IsIceInElement() || !element->IsAllFloating()) continue;
+			int el_boxid;
+			element->GetInputValue(&el_boxid,BasalforcingsPicoBoxIdEnum);
+			if(el_boxid!=boxid) continue;
+
 			Element* basalelement = element->SpawnBasalElement();
-			if(!basalelement->IsIceInElement() || !basalelement->IsFloating()) continue;
-			int el_boxid;
-			basalelement->GetInputValue(&el_boxid,BasalforcingsPicoBoxIdEnum);
-			if(el_boxid!=boxid) continue;
-
 	     	Input* overturnings_input=basalelement->GetInput(BasalforcingsPicoSubShelfOceanOverturningEnum); _assert_(overturnings_input);
 
@@ -219,5 +226,6 @@
 			overturning_weighted_avg[basinid]+=overturning*area;
 			basalelement->FindParam(&domaintype,DomainTypeEnum);
-			if(domaintype!=Domain2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
+
+			if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 		}
 
Index: issm/trunk/src/c/modules/FloatingiceMeltingRatex/FloatingiceMeltingRatex.cpp
===================================================================
--- issm/trunk/src/c/modules/FloatingiceMeltingRatex/FloatingiceMeltingRatex.cpp	(revision 25994)
+++ issm/trunk/src/c/modules/FloatingiceMeltingRatex/FloatingiceMeltingRatex.cpp	(revision 26744)
@@ -101,5 +101,5 @@
 
 		/*Set melt to 0 if non floating*/
-		if(!element->IsIceInElement() || !element->IsFloating() || !element->IsOnBase()){
+		if(!element->IsIceInElement() || !element->IsAllFloating() || !element->IsOnBase()){
 			IssmDouble* values = xNewZeroInit<IssmDouble>(numvertices);
 			element->AddInput(BasalforcingsFloatingiceMeltingRateEnum,values,P1DGEnum);
@@ -159,5 +159,5 @@
 		for(Object* & object : femmodel->elements->objects){
 			Element* element = xDynamicCast<Element*>(object);
-			if(!element->IsOnBase() || !element->IsIceInElement() || !element->IsFloating()) continue;
+			if(!element->IsOnBase() || !element->IsIceInElement() || !element->IsAllFloating()) continue;
 			/*Spawn basal element if on base to compute element area*/
 			Element* basalelement = element->SpawnBasalElement();
@@ -172,5 +172,5 @@
 			/*Delete spawned element if we are in 3D*/
 			basalelement->FindParam(&domaintype,DomainTypeEnum);
-			if(domaintype!=Domain2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
+			if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 		}
 
Index: issm/trunk/src/c/modules/FrontalForcingsx/FrontalForcingsx.cpp
===================================================================
--- issm/trunk/src/c/modules/FrontalForcingsx/FrontalForcingsx.cpp	(revision 25994)
+++ issm/trunk/src/c/modules/FrontalForcingsx/FrontalForcingsx.cpp	(revision 26744)
@@ -6,15 +6,19 @@
 #include "../../shared/shared.h"
 #include "../../toolkits/toolkits.h"
+#include "../../shared/Random/random.h"
 
-void FrontalForcingsx(FemModel* femmodel){
+void FrontalForcingsx(FemModel* femmodel){/*{{{*/
 
 	/*Recover melt_parameterization*/
 	int melt_parameterization;
 	femmodel->parameters->FindParam(&melt_parameterization,FrontalForcingsParamEnum);
-	
+
 	/*Calculate melting rate*/
 	switch(melt_parameterization){
 		case FrontalForcingsDefaultEnum:
 			break;
+		case FrontalForcingsRignotAutoregressionEnum:
+			Thermalforcingautoregressionx(femmodel);
+			/*Do not break here, call IcefrontAreax(),RignotMeltParameterizationx()*/
 		case FrontalForcingsRignotEnum:
 			femmodel->IcefrontAreax();
@@ -24,3 +28,93 @@
 			_error_("Frontal forcings "<<EnumToStringx(melt_parameterization)<<" not supported yet");
 	}
-}
+}/*}}}*/
+void ThermalforcingautoregressionInitx(FemModel* femmodel){/*{{{*/
+
+   /*Initialization step of Thermalforcingautoregressionx*/
+   int M,N,Nphi,arorder,numbasins,my_rank;
+   IssmDouble starttime,tstep_ar,tinit_ar;
+   femmodel->parameters->FindParam(&numbasins,FrontalForcingsNumberofBasinsEnum);
+   femmodel->parameters->FindParam(&arorder,FrontalForcingsAutoregressiveOrderEnum);
+   IssmDouble* beta0    = NULL;
+   IssmDouble* beta1    = NULL;
+   IssmDouble* phi      = NULL;
+   femmodel->parameters->FindParam(&starttime,TimesteppingStartTimeEnum);
+   femmodel->parameters->FindParam(&tstep_ar,FrontalForcingsAutoregressionTimestepEnum);
+   femmodel->parameters->FindParam(&tinit_ar,FrontalForcingsAutoregressionInitialTimeEnum);
+   femmodel->parameters->FindParam(&beta0,&M,FrontalForcingsBeta0Enum);    _assert_(M==numbasins);
+   femmodel->parameters->FindParam(&beta1,&M,FrontalForcingsBeta1Enum);    _assert_(M==numbasins);
+   femmodel->parameters->FindParam(&phi,&M,&Nphi,FrontalForcingsPhiEnum);  _assert_(M==numbasins); _assert_(Nphi==arorder);
+
+   /*AR model spin-up with 0 noise to initialize ThermalforcingValuesAutoregressionEnum*/
+	int nspin{2*arorder+5};
+   for(Object* &object:femmodel->elements->objects){
+      Element* element      = xDynamicCast<Element*>(object); //generate element object
+      element->AutoregressionInit(numbasins,arorder,nspin,starttime,tstep_ar,tinit_ar,beta0,beta1,phi,FrontalForcingsRignotAutoregressionEnum);
+   }
+
+   /*Cleanup*/
+   xDelete<IssmDouble>(beta0);
+   xDelete<IssmDouble>(beta1);
+   xDelete<IssmDouble>(phi);
+}/*}}}*/
+void Thermalforcingautoregressionx(FemModel* femmodel){/*{{{*/
+
+   /*Get time parameters*/
+   IssmDouble time,dt,starttime,tstep_ar;
+   femmodel->parameters->FindParam(&time,TimeEnum);
+   femmodel->parameters->FindParam(&dt,TimesteppingTimeStepEnum);
+   femmodel->parameters->FindParam(&starttime,TimesteppingStartTimeEnum);
+   femmodel->parameters->FindParam(&tstep_ar,FrontalForcingsAutoregressionTimestepEnum);
+
+   /*Initialize module at first time step*/
+   if(time<=starttime+dt){ThermalforcingautoregressionInitx(femmodel);}
+   /*Determine if this is a time step for the AR model*/
+   bool isstepforar = false;
+
+   #ifndef _HAVE_AD_
+   if((fmod(time,tstep_ar)<fmod((time-dt),tstep_ar)) || (time<=starttime+dt) || tstep_ar==dt) isstepforar = true;
+   #else
+   _error_("not implemented yet");
+   #endif
+
+   /*Load parameters*/
+	bool isstochastic;
+   bool istfstochastic = false;
+	int M,N,Nphi,arorder,numbasins,my_rank;
+   femmodel->parameters->FindParam(&numbasins,FrontalForcingsNumberofBasinsEnum);
+   femmodel->parameters->FindParam(&arorder,FrontalForcingsAutoregressiveOrderEnum);
+   IssmDouble tinit_ar;
+   IssmDouble* beta0      = NULL;
+   IssmDouble* beta1      = NULL;
+   IssmDouble* phi        = NULL;
+
+	femmodel->parameters->FindParam(&tinit_ar,FrontalForcingsAutoregressionInitialTimeEnum);
+   femmodel->parameters->FindParam(&beta0,&M,FrontalForcingsBeta0Enum);    _assert_(M==numbasins);
+   femmodel->parameters->FindParam(&beta1,&M,FrontalForcingsBeta1Enum);    _assert_(M==numbasins);
+   femmodel->parameters->FindParam(&phi,&M,&Nphi,FrontalForcingsPhiEnum);  _assert_(M==numbasins); _assert_(Nphi==arorder);
+
+	femmodel->parameters->FindParam(&isstochastic,StochasticForcingIsStochasticForcingEnum);
+	if(isstochastic){
+		int  numstochasticfields;
+		int* stochasticfields;
+		femmodel->parameters->FindParam(&numstochasticfields,StochasticForcingNumFieldsEnum);
+		femmodel->parameters->FindParam(&stochasticfields,&N,StochasticForcingFieldsEnum); _assert_(N==numstochasticfields);
+		for(int i=0;i<numstochasticfields;i++){
+			if(stochasticfields[i]==FrontalForcingsRignotAutoregressionEnum) istfstochastic = true;
+		}
+		xDelete<int>(stochasticfields);
+	}
+   /*Time elapsed with respect to AR model initial time*/
+   IssmDouble telapsed_ar = time-tinit_ar;
+
+   /*Loop over each element to compute Thermal Forcing at vertices*/
+   for(Object* &object:femmodel->elements->objects){
+      Element* element = xDynamicCast<Element*>(object);
+      element->Autoregression(isstepforar,arorder,telapsed_ar,beta0,beta1,phi,istfstochastic,FrontalForcingsRignotAutoregressionEnum);
+   }
+
+   /*Cleanup*/
+   xDelete<IssmDouble>(beta0);
+   xDelete<IssmDouble>(beta1);
+   xDelete<IssmDouble>(phi);
+}/*}}}*/
Index: issm/trunk/src/c/modules/FrontalForcingsx/FrontalForcingsx.h
===================================================================
--- issm/trunk/src/c/modules/FrontalForcingsx/FrontalForcingsx.h	(revision 25994)
+++ issm/trunk/src/c/modules/FrontalForcingsx/FrontalForcingsx.h	(revision 26744)
@@ -7,4 +7,6 @@
 /* local prototypes: */
 void FrontalForcingsx(FemModel* femmodel);
+void ThermalforcingautoregressionInitx(FemModel* femmodel);
+void Thermalforcingautoregressionx(FemModel* femmodel);
 
 #endif
Index: issm/trunk/src/c/modules/GiaDeflectionCorex/GiaDeflectionCorex.cpp
===================================================================
--- issm/trunk/src/c/modules/GiaDeflectionCorex/GiaDeflectionCorex.cpp	(revision 25994)
+++ issm/trunk/src/c/modules/GiaDeflectionCorex/GiaDeflectionCorex.cpp	(revision 26744)
@@ -44,110 +44,55 @@
 void GiaDeflectionCorex( IssmDouble* pwi, IssmDouble* pdwidt, GiaDeflectionCoreArgs* arguments){
 
-	/*intermediary: */
-	int i;
-
-	/*output: */
-	IssmDouble wi=0;
-	IssmDouble dwidt=0;
-
-	/*inputs: {{{*/
-	/*constant: */
-	int idisk=1; // disk #
-	IssmDouble yts;
-
-	/*coming from the model structure, runtime configurable:*/
-	/*gia solution parameters: */
-	int iedge=0; 
-
-	/*gia inputs: */
-	IssmDouble ri; //radial distance from center of disk to vertex  i
-	IssmDouble re; //radius of disk
-	IssmDouble* hes; //loading history (in ice thickness)
-	IssmDouble* times; //loading history times
-	int numtimes; //loading history length
-	IssmDouble currenttime;
-	int Ntime; // number of times with load history 
-	int Ntimm; // Ntime-1 : for slope/y-cept of load segments 
-	int Ntimp; // Ntime+1 : for evaluation time  
-	IssmDouble* blockt_time=NULL;
-	IssmDouble* blockt_bi=NULL;
-	IssmDouble* blockt_dmi=NULL;
-	IssmDouble* blocky_zhload=NULL;
-
-	/*gia material parameters: */
-	IssmDouble lithosphere_shear_modulus;
-	IssmDouble lithosphere_density;
-	IssmDouble mantle_shear_modulus;
-	IssmDouble mantle_viscosity;
-	IssmDouble mantle_density;
-	IssmDouble lithosphere_thickness;
-
-	/*ice properties: */
-	IssmDouble rho_ice;
-
-	/*some debug info: */
-	int disk_id;
-
-/*}}}*/
-
 	/*Recover material parameters and loading history: see GiaDeflectionCoreArgs for more details {{{*/
-	ri                        = arguments->ri;
-	re                        = arguments->re;
-	hes                       = arguments->hes;
-	times                     = arguments->times;
-	numtimes                  = arguments->numtimes;
-	currenttime               = arguments->currenttime;
-	lithosphere_shear_modulus = arguments->lithosphere_shear_modulus;
-	lithosphere_density       = arguments->lithosphere_density;
-	mantle_shear_modulus      = arguments->mantle_shear_modulus;
-	mantle_viscosity          = arguments->mantle_viscosity;
-	mantle_density            = arguments->mantle_density;
-	lithosphere_thickness     = arguments->lithosphere_thickness;
-	rho_ice                   = arguments->rho_ice;
-	disk_id                   = arguments->idisk;
-	iedge                     = arguments->iedge;
-	yts                       = arguments->yts;
+	IssmDouble  ri                        = arguments->ri;                        //radial distance from center of disk to vertex i
+	IssmDouble  re                        = arguments->re;                        //radius of disk
+	IssmDouble *hes                       = arguments->hes;                       //loading history (in ice thickness)
+	IssmDouble *times                     = arguments->times;                     //loading history times
+	int         numtimes                  = arguments->numtimes;                  //loading history length
+	IssmDouble  currenttime               = arguments->currenttime;
+	IssmDouble  lithosphere_shear_modulus = arguments->lithosphere_shear_modulus;
+	IssmDouble  lithosphere_density       = arguments->lithosphere_density;
+	IssmDouble  mantle_shear_modulus      = arguments->mantle_shear_modulus;
+	IssmDouble  mantle_viscosity          = arguments->mantle_viscosity;
+	IssmDouble  mantle_density            = arguments->mantle_density;
+	IssmDouble  lithosphere_thickness     = arguments->lithosphere_thickness;
+	IssmDouble  rho_ice                   = arguments->rho_ice;
+	int         disk_id                   = arguments->idisk;
+	int         iedge                     = arguments->iedge;
+	IssmDouble  yts                       = arguments->yts;
 
 	/*}}}*/
 
 	/*Modify inputs to match naruse code: */
-	Ntime=numtimes;
-	Ntimm=Ntime-1;
-	Ntimp=Ntime+1;
+	int Ntime=numtimes; // number of times with load history
+	int Ntimm=Ntime-1; // Ntime-1 : for slope/y-cept of load segments
+	int Ntimp=Ntime+1; // Ntime+1 : for evaluation time
 
 	/*Prepare block inputs for fortran distme and what0 routines of the naruse code: {{{*/
 	/*Now, let's set pset from the data that we got in input to GiaDeflectionCorex: */
-	blockp_.pset[0]=lithosphere_thickness;
-	blockp_.pset[1]=mantle_viscosity;
-	blockp_.pset[2]=lithosphere_shear_modulus;
-	blockp_.pset[3]=mantle_shear_modulus;
-	blockp_.pset[4]=lithosphere_density;
-	blockp_.pset[5]=mantle_density;
-	blockp_.pset[6]=re;
-	blocko_.rhoi=rho_ice; 
+	blockp_.pset[0]=reCast<IssmPDouble>(lithosphere_thickness);
+	blockp_.pset[1]=reCast<IssmPDouble>(mantle_viscosity);
+	blockp_.pset[2]=reCast<IssmPDouble>(lithosphere_shear_modulus);
+	blockp_.pset[3]=reCast<IssmPDouble>(mantle_shear_modulus);
+	blockp_.pset[4]=reCast<IssmPDouble>(lithosphere_density);
+	blockp_.pset[5]=reCast<IssmPDouble>(mantle_density);
+	blockp_.pset[6]=reCast<IssmPDouble>(re);
+	blocko_.rhoi=reCast<IssmPDouble>(rho_ice); 
+   blockrad_.distrad=reCast<IssmPDouble>(ri)/1000.0; // in km
 
 	/*loading history: */
-	blocky_zhload=xNew<IssmDouble>(Ntime);
-	for(i=0;i<Ntime;i++){
-	blocky_zhload[i]=hes[i];
+	IssmPDouble* blocky_zhload=xNew<IssmPDouble>(Ntime);
+	for(int i=0;i<Ntime;i++) blocky_zhload[i]=reCast<IssmPDouble>(hes[i]);
+
+	/*times in kyr: */
+	IssmPDouble* blockt_time=xNew<IssmPDouble>(Ntimp);
+	for(int i=0;i<Ntimp;i++){
+		blockt_time[i]=times[i]/1000.0/yts; 
+		if(i==numtimes-1) blockt_time[i]=reCast<IssmPDouble>(times[numtimes-1])/1000.0/yts; // final loading time, same as evaluation time
+		if(i==numtimes)   blockt_time[i]=reCast<IssmPDouble>(times[numtimes-1])/1000.0/yts;   // evaluation time
 	}
 
-	/*times in kyr: */
-	blockt_time=xNew<IssmDouble>(Ntimp);
-	for (i=0;i<Ntimp;i++){
-		blockt_time[i]=times[i]/1000.0/yts; 
-		if(i==numtimes-1)blockt_time[i]=times[numtimes-1]/1000.0/yts; // final loading time, same as evaluation time
-		if(i==numtimes)blockt_time[i]=times[numtimes-1]/1000.0/yts;   // evaluation time
-	}
-
-	/*bi: */
-	blockt_bi=xNew<IssmDouble>(Ntimm);
-
-	/*dmi: */
-	blockt_dmi=xNew<IssmDouble>(Ntimm);
-
-	/*radial distance of i-th element: */
-	blockrad_.distrad=ri/1000.0; // in km
-	/*}}}*/
+	IssmPDouble* blockt_bi=xNew<IssmPDouble>(Ntimm);
+	IssmPDouble* blockt_dmi=xNew<IssmPDouble>(Ntimm);
 
 	/*Call distme driver: */
@@ -158,14 +103,12 @@
 
 	/*output solution: */
-	wi = blocks_.aswokm_w;
-	dwidt = blocks_.aswokm_dwdt;
-	*pwi=wi;
-	*pdwidt=dwidt;
+	*pwi=reCast<IssmDouble>(blocks_.aswokm_w);
+	*pdwidt=reCast<IssmDouble>(blocks_.aswokm_dwdt);
 
 	/*Free ressources: */
-	xDelete<IssmDouble>(blockt_time);
-	xDelete<IssmDouble>(blockt_bi);
-	xDelete<IssmDouble>(blockt_dmi);
-	xDelete<IssmDouble>(blocky_zhload);
+	xDelete<IssmPDouble>(blockt_time);
+	xDelete<IssmPDouble>(blockt_bi);
+	xDelete<IssmPDouble>(blockt_dmi);
+	xDelete<IssmPDouble>(blocky_zhload);
 
 }
Index: issm/trunk/src/c/modules/InputUpdateFromConstantx/InputUpdateFromConstantx.cpp
===================================================================
--- issm/trunk/src/c/modules/InputUpdateFromConstantx/InputUpdateFromConstantx.cpp	(revision 25994)
+++ issm/trunk/src/c/modules/InputUpdateFromConstantx/InputUpdateFromConstantx.cpp	(revision 26744)
@@ -27,4 +27,5 @@
 	}
 }
+
 void InputUpdateFromConstantx(FemModel* femmodel,IssmDouble constant, int name){
 
@@ -60,4 +61,26 @@
 	}
 }
+
+void InputUpdateFromConstantx(Inputs* inputs,Elements* elements,IssmDouble constant, int name,int type){
+
+	if(type==P0Enum) InputUpdateFromConstantx(inputs, elements, constant,name);
+	else if(type==P1Enum){
+
+		if(VerboseModule()) _printf0_("   Input updates from constant (P1 version)\n");
+
+		/*Elements and loads drive the update: */
+		if(IsInputEnum(name)){
+			for(Object* & object : elements->objects){
+				Element* element = xDynamicCast<Element*>(object);
+				element->InputUpdateFromConstant(constant,name,P1Enum);
+			}
+		}
+		else{
+			_error_("not supported yet");
+		}
+	}
+	else _error_("InputUpdateFromConstantx error message: type not supported yet!");
+
+}
 void InputUpdateFromConstantx(Inputs* inputs,Elements* elements,bool constant, int name){
 
Index: issm/trunk/src/c/modules/InputUpdateFromConstantx/InputUpdateFromConstantx.h
===================================================================
--- issm/trunk/src/c/modules/InputUpdateFromConstantx/InputUpdateFromConstantx.h	(revision 25994)
+++ issm/trunk/src/c/modules/InputUpdateFromConstantx/InputUpdateFromConstantx.h	(revision 26744)
@@ -17,4 +17,5 @@
 #endif
 void InputUpdateFromConstantx(Inputs* inputs,Elements* elements,IssmDouble constant,int name);
+void InputUpdateFromConstantx(Inputs* inputs,Elements* elements,IssmDouble constant,int name, int type);
 void InputUpdateFromConstantx(Inputs* inputs,Elements* elements,bool       constant,int name);
 
Index: issm/trunk/src/c/modules/InputUpdateFromDakotax/InputUpdateFromDakotax.cpp
===================================================================
--- issm/trunk/src/c/modules/InputUpdateFromDakotax/InputUpdateFromDakotax.cpp	(revision 25994)
+++ issm/trunk/src/c/modules/InputUpdateFromDakotax/InputUpdateFromDakotax.cpp	(revision 26744)
@@ -38,5 +38,4 @@
 	femmodel->parameters->FindParam(&variable_partitions_nt,NULL,NULL,QmuVariablePartitionsNtEnum);
 
-
 	/*Go through all dakota descriptors, ex: "rho_ice","thermal_conductivity","thickness1","thickness2", etc ..., and
 	 * for each descriptor, take the variable value and plug it into the inputs (more or less :)):
@@ -50,5 +49,4 @@
 		descriptor=variables_descriptors[i];
 
-
 		/*From descriptor, figure out if the variable is scaled, indexed, distributed or just a simple variable: */
 		if (strncmp(descriptor,"scaled_",7)==0){
@@ -160,5 +158,5 @@
 
 	/*Here, we put all the code that cannot be handled any other place: */
-	if (strncmp(root,"SurfaceloadModelid",18)==0){
+	if (strncmp(root,"SurfaceloadModelid",18)==0){ //surface load in solid earth class {{{
 
 		if(VerboseQmu()){
@@ -168,7 +166,6 @@
 		}
 
-
-		if (femmodel->inputs->GetInputObjectEnum(SurfaceloadIceThicknessChangeEnum)==DatasetInputEnum)
-			MmeToInput(femmodel,distributed_values,variable_partition,npart,SurfaceloadIceThicknessChangeEnum, P0Enum);
+		if (femmodel->inputs->GetInputObjectEnum(MasstransportSpcthicknessEnum)==DatasetInputEnum)
+			MmeToInput(femmodel,distributed_values,variable_partition,npart,MasstransportSpcthicknessEnum, P0Enum);
 
 		if (femmodel->inputs->GetInputObjectEnum(MaskIceLevelsetEnum)==DatasetInputEnum)
@@ -178,5 +175,29 @@
 			MmeToInput(femmodel,distributed_values,variable_partition,npart,MaskOceanLevelsetEnum, P1Enum);
 
-	}
+	} /*}}}*/
+	if (strncmp(root,"SolidearthExternalModelid",18)==0){ //external solid earth solution in solid earth class {{{
+
+		if(VerboseQmu()){
+			_printf0_("      SolidearthExternalModelid MME, with ids: ");
+			for (int i=0;i<npart;i++)_printf0_((int)distributed_values[i] << " ");
+			_printf0_("\n");
+		}
+
+		if (femmodel->inputs->GetInputObjectEnum(SolidearthExternalDisplacementEastRateEnum)==DatasetInputEnum)
+			MmeToInput(femmodel,distributed_values,variable_partition,npart,SolidearthExternalDisplacementEastRateEnum, P1Enum);
+
+		if (femmodel->inputs->GetInputObjectEnum(SolidearthExternalDisplacementUpRateEnum)==DatasetInputEnum)
+			MmeToInput(femmodel,distributed_values,variable_partition,npart,SolidearthExternalDisplacementUpRateEnum, P1Enum);
+
+		if (femmodel->inputs->GetInputObjectEnum(SolidearthExternalDisplacementNorthRateEnum)==DatasetInputEnum)
+			MmeToInput(femmodel,distributed_values,variable_partition,npart,SolidearthExternalDisplacementNorthRateEnum, P1Enum);
+
+		if (femmodel->inputs->GetInputObjectEnum(SolidearthExternalGeoidRateEnum)==DatasetInputEnum)
+			MmeToInput(femmodel,distributed_values,variable_partition,npart,SolidearthExternalGeoidRateEnum, P1Enum);
+
+		//if (femmodel->inputs->GetInputObjectEnum(SolidearthExternalBarystaticSeaLevelRateEnum)==DatasetInputEnum)
+		//	MmeToInput(femmodel,distributed_values,variable_partition,npart,SolidearthExternalBarystaticSeaLevelRateEnum, P1Enum);
+	} /*}}}*/
+
 	else _error_("InputUpdateSpecialtyCode error message: " << root << " not supported yet!");
 
@@ -235,5 +256,5 @@
 	}
 
-	/*wipe out existing SurfaceloadIceThicknessChangeEnum dataset:*/
+	/*wipe out existing SurfaceloadIceThicknessRateEnum dataset:*/
 	femmodel->inputs->ChangeEnum(DummyEnum,rootenum);
 
@@ -263,4 +284,3 @@
 	}
 
-
 } /*}}}*/
Index: issm/trunk/src/c/modules/InterpFromMeshToMesh2dx/InterpFromMeshToMesh2dx.h
===================================================================
--- issm/trunk/src/c/modules/InterpFromMeshToMesh2dx/InterpFromMeshToMesh2dx.h	(revision 25994)
+++ issm/trunk/src/c/modules/InterpFromMeshToMesh2dx/InterpFromMeshToMesh2dx.h	(revision 26744)
@@ -9,5 +9,5 @@
 
 int InterpFromMeshToMesh2dx(double** pdata_interp,int* index_data,double* x_data,double* y_data,int nods_data,int nels_data,
-			double* data,int M_data,int N_data,double* x_interp,double* y_interp,int N_interp,Options* options);
+			double* data,int M_data,int N_data,double* x_interp,double* y_interp,int N_interp,Options* options=NULL);
 
 #endif
Index: issm/trunk/src/c/modules/IoModelToConstraintsx/IoModelToConstraintsx.cpp
===================================================================
--- issm/trunk/src/c/modules/IoModelToConstraintsx/IoModelToConstraintsx.cpp	(revision 25994)
+++ issm/trunk/src/c/modules/IoModelToConstraintsx/IoModelToConstraintsx.cpp	(revision 26744)
@@ -666,5 +666,5 @@
 					if((iomodel->my_vertices[i])){
 						if (!xIsNan<IssmDouble>(spcdata[i])){
-							constraints->AddObject(new SpcDynamic(count+1,i+1,dof,analysis_type));
+							constraints->AddObject(new SpcDynamic(count+1,i+1,dof,spcdata[i],analysis_type));
 							count++;
 						}
@@ -676,19 +676,16 @@
 					if((iomodel->my_vertices[i])){
 						if (!xIsNan<IssmDouble>(spcdata[i])){
-							constraints->AddObject(new SpcDynamic(count+1,i+1,dof,analysis_type));
-							count++;
-						}
-					}
-				}
-				for(i=0;i<iomodel->numberofedges;i++){
-					if(iomodel->edges[i*3+2]==2){
-						if(iomodel->my_edges[i]){
-							v1 = iomodel->edges[3*i+0]-1;
-							v2 = iomodel->edges[3*i+1]-1;
-							if(!xIsNan<IssmDouble>(spcdata[v1]) && !xIsNan<IssmDouble>(spcdata[v2])){
-								constraints->AddObject(new SpcDynamic(count+1,iomodel->numberofvertices+i+1,
-												dof,analysis_type));
-								count++;
-							}
+							constraints->AddObject(new SpcDynamic(count+1,i+1,dof,spcdata[i],analysis_type));
+							count++;
+						}
+					}
+				}
+				for(i=0;i<iomodel->numberofverticaledges;i++){
+					if(iomodel->my_vedges[i]){
+						v1 = iomodel->verticaledges[2*i+0]-1;
+						v2 = iomodel->verticaledges[2*i+1]-1;
+						if(!xIsNan<IssmDouble>(spcdata[v1]) && !xIsNan<IssmDouble>(spcdata[v2])){
+							constraints->AddObject(new SpcDynamic(count+1,iomodel->numberofvertices+i+1,dof,(spcdata[v1]+spcdata[v2])/2.,analysis_type));
+							count++;
 						}
 					}
@@ -699,19 +696,19 @@
 					if((iomodel->my_vertices[i])){
 						if (!xIsNan<IssmDouble>(spcdata[i])){
-							constraints->AddObject(new SpcDynamic(count+1,i+1,dof,analysis_type));
-							count++;
-						}
-					}
-				}
-				for(i=0;i<iomodel->numberofedges;i++){
-					if(iomodel->edges[i*3+2]==2){
-						if(iomodel->my_edges[i]){
-							v1 = iomodel->edges[3*i+0]-1;
-							v2 = iomodel->edges[3*i+1]-1;
-							if(!xIsNan<IssmDouble>(spcdata[v1]) && !xIsNan<IssmDouble>(spcdata[v2])){
-								constraints->AddObject(new SpcDynamic(count+1,iomodel->numberofvertices+2*i+1,dof,analysis_type));
-								constraints->AddObject(new SpcDynamic(count+2,iomodel->numberofvertices+2*i+2,dof,analysis_type));
-								count=count+2;
-							}
+							constraints->AddObject(new SpcDynamic(count+1,i+1,dof,spcdata[i],analysis_type));
+							count++;
+						}
+					}
+				}
+				for(i=0;i<iomodel->numberofverticaledges;i++){
+					if(iomodel->my_vedges[i]){
+						v1 = iomodel->verticaledges[2*i+0]-1;
+						v2 = iomodel->verticaledges[2*i+1]-1;
+						if(!xIsNan<IssmDouble>(spcdata[v1]) && !xIsNan<IssmDouble>(spcdata[v2])){
+							constraints->AddObject(new SpcDynamic(count+1,iomodel->numberofvertices+2*i+1,
+											dof,2./3.*spcdata[v1]+1./3.*spcdata[v2],analysis_type));
+							constraints->AddObject(new SpcDynamic(count+2,iomodel->numberofvertices+2*i+2,
+											dof,1./3.*spcdata[v1]+2./3.*spcdata[v2],analysis_type));
+							count=count+2;
 						}
 					}
